package com.jiuqi.util.tree;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.jiuqi.util.tree.TreeIterator;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

public class TreeNode {
  private Object item;
  
  private com.jiuqi.util.tree.TreeNode parent;
  
  private List children = new ArrayList();
  
  private Object tag;
  
  public TreeNode() {}
  
  public TreeNode(Object item) {
    this();
    this.item = item;
  }
  
  public Object getItem() {
    return this.item;
  }
  
  public void setItem(Object item) {
    this.item = item;
  }
  
  public com.jiuqi.util.tree.TreeNode getParent() {
    return this.parent;
  }
  
  public void setParent(com.jiuqi.util.tree.TreeNode parent) {
    if (this.parent != null)
      this.parent.children.remove(this); 
    this.parent = parent;
    if (parent != null)
      parent.children.add(this); 
  }
  
  public int size() {
    return this.children.size();
  }
  
  public com.jiuqi.util.tree.TreeNode get(int index) {
    return this.children.get(index);
  }
  
  public void add(int index, com.jiuqi.util.tree.TreeNode node) {
    node.setParent(null);
    this.children.add(index, node);
    node.parent = this;
  }
  
  public void remove(int index) {
    remove(get(index));
  }
  
  public void remove(com.jiuqi.util.tree.TreeNode node) {
    node.setParent(null);
  }
  
  public com.jiuqi.util.tree.TreeNode[] getChildren() {
    return (com.jiuqi.util.tree.TreeNode[])this.children.toArray((Object[])new com.jiuqi.util.tree.TreeNode[0]);
  }
  
  public int level() {
    int level = 0;
    com.jiuqi.util.tree.TreeNode p = getParent();
    while (p != null) {
      level++;
      p = p.getParent();
    } 
    return level;
  }
  
  public Object getTag() {
    return this.tag;
  }
  
  public void setTag(Object tag) {
    this.tag = tag;
  }
  
  public Iterator iterator() {
    return (Iterator)new TreeIterator(this);
  }
  
  public String toString() {
    StringBuffer buffer = new StringBuffer("[Level: ");
    buffer.append(level());
    buffer.append("; Node: ");
    buffer.append((this.item == null) ? "<null>" : this.item.toString());
    buffer.append(", Children: ");
    buffer.append(size());
    buffer.append(']');
    return buffer.toString();
  }
}
